<?php
date_default_timezone_set('Asia/Tokyo');
$rbs = new rbs_theme_option;

/*-------------------------------------------*/
/*	管理画面追加
/*-------------------------------------------*/
function biz_vektor_rbs_theme_options_add_page() {
	$theme_page = add_theme_page(
		'rbs_option',   					// Name of page
		'RBS拡張機能',   					// Label in menu
		'administrator',				// Capability required
		'rbs_theme_options',					// Menu slug, used to uniquely identify the page
		'biz_vektor_rbs_theme_options_render_page' // Function that renders the options page
	);

	if ( !$theme_page )
		return;
}
add_action( 'admin_menu', 'biz_vektor_rbs_theme_options_add_page' );

function biz_vektor_rbs_options_validate($input){

	return $input;
}

function biz_vektor_rbs_options($input){
   $biz_vektor_options = biz_vektor_get_theme_options();

   if($input['menu_position'] == 'left'){
        $biz_vektor_options['topSideBarDisplay'] = false;
        $biz_vektor_options['theme_layout'] = 'sidebar-content';
	    update_option('biz_vektor_theme_options',$biz_vektor_options);
    }
    elseif($input['menu_position'] == 'right'){
        $biz_vektor_options['topSideBarDisplay'] = false;
        $biz_vektor_options['theme_layout'] = 'content-sidebar';
	    update_option('biz_vektor_theme_options',$biz_vektor_options);
    }

    return $input;
}

function biz_vektor_rbs_option_register(){
    register_setting( 'biz_vektor_rbs_options', 'biz_vektor_rbs_options', 'biz_vektor_rbs_options' );
}
add_action('admin_init', 'biz_vektor_rbs_option_register');

/*-------------------------------------------*/
/*  設定画面
/*-------------------------------------------*/
function biz_vektor_rbs_theme_options_render_page(){
	if(isset($_POST['_wpnonce_bvectorrbs'])){biz_vektor_rbs_check_postdata();}
	$options = biz_vektor_get_rbs_theme_options();
	?>
<style type="text/css">
#biz_vektor_options.rbs_extora_optionpage textarea{
	width:600px;
	height:200px;
}
#biz_vektor_options .counddown_styles {
	width:100%;
}
#biz_vektor_options .counddown_styles:after {
	clear:both;
}
#biz_vektor_options .counddown_styles li{
	float:left;
	display:block;
	width:170px;
}
</style>
<script type="text/javascript">
jQuery(function($){
	$(document).ready(disabledsycle());
	$(".cd_display_header_enable").change(function(){disabledsycle();});
	$(".custom_child_header").change(function(){disabledsycle();});

	function disabledsycle(){
		if($(".cd_display_header_enable").is(":checked")){
			$(".ta_text").attr("disabled","disabled");
		}else{
			$(".ta_text").removeAttr("disabled");
		}
		if($(".custom_child_header").val()==''){
			$(".custom_child_header").css("background-color", "#ffffff");
		}else{
			$(".custom_child_header").css("background-color", "#ffffee");
		}
	}
});
</script>

	<div class="wrap rbs_extora_optionpage" id="biz_vektor_options" >
		<?php screen_icon(); ?>
		<?php dbg($options,'$options'); ?>
		<h2 style="margin-bottom:13px;font-size:2.3em">RBS拡張機能</h2>


		<form method="post" action="">
      <?php wp_nonce_field('fjitcfdstnitoriplsaekkji', '_wpnonce_bvectorrbs'); ?>

		<input type="hidden" name="action_flag" value="biz_vektor_rbs_options" />
		<table class="form-table">
		<tr>
		<th>カウントダウンのタイトル</th>
		<td><input type="text" name="biz_vektor_rbs_options[cd_text]" id="contact_txt" value="<?php echo $options['cd_text']; ?>" /></td>
		</tr><tr>
		<th>カウントダウンの時間</th>
		<td>
		<input type="date" name="biz_vektor_rbs_options[cd_date_d]" id="contact_txt" value="<?php echo date('Y-m-d',$options['cd_date']); ?>" min="<?php echo date('Y-m-d'); ?> " />
		<input type="time" name="biz_vektor_rbs_options[cd_date_t]" id="contact_txt" value="<?php echo date('H:i',$options['cd_date']); ?>"  /></td>
		</tr><tr>
		<th>カウントダウン出力</th>
		<td>
		<label><input type="checkbox" class="cd_display_header_enable" name="biz_vektor_rbs_options[cd_display_header_enable]" value="true" <?php echo($options['cd_display_header_enable'])? 'checked': '' ; ?> />ヘッダーエリアにカウントダウンを表示する</label>
		</td>
		</tr><tr>
		<th>カウントダウンデザイン</th>
		<td><ul class="counddown_styles">
		<li><label><input type="radio" name="biz_vektor_rbs_options[cd_display_design]" value="0" <?php echo(!$options['cd_display_design'])? 'checked': '' ; ?> />Basic<img src="<?php echo get_template_directory_uri().'/images/'; ?>pattern0.jpg" /></label></li>
		<li><label><input type="radio" name="biz_vektor_rbs_options[cd_display_design]" value="1" <?php echo($options['cd_display_design'] == 1)? 'checked': '' ; ?> />Shine<img src="<?php echo get_template_directory_uri().'/images/'; ?>pattern1.jpg" /></label></li>
		<li><label><input type="radio" name="biz_vektor_rbs_options[cd_display_design]" value="2" <?php echo($options['cd_display_design'] == 2)? 'checked': '' ; ?> />Customize01<img src="<?php echo get_template_directory_uri().'/images/'; ?>pattern2.jpg" /></label></li>
		<li><label><input type="radio" name="biz_vektor_rbs_options[cd_display_design]" value="3" <?php echo($options['cd_display_design'] == 3)? 'checked': '' ; ?> />Customize02<img src="<?php echo get_template_directory_uri().'/images/'; ?>pattern3.jpg" /></label></li>
		</td></ul>
		</tr><tr>
		<th>ヘッダーエリア:追加テキスト<br/>((htmlタグ使用可能）<br/><span style="font-size:0.8em">※ヘッダーエリアにカウントダウンを表示しているにチェックを入れている場合は表示されません</span></th>
		<td>
		<label><textarea  name="biz_vektor_rbs_options[ta_text]" class="ta_text" ><?php echo $options['ta_text'] ; ?></textarea></label>
		</td><tr>
		<th>下層ページ:カスタマイズヘッダー<br/>(htmlタグ使用可能）<br/><span style="font-size:0.8em">※この項目に入力があると下層ページのヘッダーが入力した内容と入れ替わります</span></th>
		<td>
		<label><textarea  name="biz_vektor_rbs_options[custom_child_header]" class="custom_child_header" ><?php echo $options['custom_child_header'] ; ?></textarea></label>
		</td><tr>
		<th>カスタムCSS<br/><span style="font-size:0.8em">※全ページに適用されます</span></th>
		<td>
		<label><textarea  name="biz_vektor_rbs_options[custom_css]"  ><?php echo (isset($options['custom_css']))? $options['custom_css'] : ''; ?></textarea></label>
		</td><tr>
		<th>3カラムを有効にする</th>
		<td>
		<label><input type="checkbox" name="biz_vektor_rbs_options[enable_three_cullum]" value="true" <?php echo ($options['enable_three_cullum'])? 'checked="checked"' : '' ; ?> /></label>
		</td>
		</tr>	
		<tr>
		<th>メインページスライダーをループさせる</th>
		<td>
		<label><input type="checkbox" name="biz_vektor_rbs_options[top_slider_loop]" value="true" <?php echo ($options['top_slider_loop'])? 'checked="checked"' : '' ; ?> /></label>
		</td>
		</tr>

		<?php if(false): ?>
		<label><input type="checkbox" name="biz_vektor_rbs_options[debug_mode]" value="true" <?php echo ($options['debug_mode'])? 'checked="checked"' : '' ; ?> /> Debug Mode</label>
		<?php else: ?><input type="hidden" name="biz_vektor_rbs_options[debug_mode]" value="true" />
		<?php endif; ?>
		</table>
		<?php submit_button(); ?>
		<?php // wp_nonce_field( 'my-nonce-key', 'my-submenu' ); ?>
		</form>
		<?php if($options['debug_mode']): ?>
			<form method="post" action="">
			<input type="hidden" name="action_flag" value="biz_vektor_rbs_options_reset" />
			<p class="submit"><input type="submit" name="submit" id="submit" class="button button-primary" value="Reset"  /></p>
			</form>
		<?php endif; ?>
	</div><!-- wrap -->
	<?php
}

function biz_vektor_rbs_check_postdata(){
	global $rbs;
	if(check_admin_referer('fjitcfdstnitoriplsaekkji', '_wpnonce_bvectorrbs')&&isset($_POST['action_flag'])){
		switch ($_POST['action_flag']) {
			case 'biz_vektor_rbs_options':
				$input =	$_POST['biz_vektor_rbs_options'];
				//$output = $rbs->make_default_option();
				$output = biz_vektor_get_rbs_theme_options();

				$output['cd_text'] = $input['cd_text'] ;
				$output['cd_date'] = ($input['cd_date_d'] && $input['cd_date_t'])? strtotime($input['cd_date_d'].' '.$input['cd_date_t'].':00') : time() + 30 * 24 * 60 * 60;
				$output['cd_display_header_enable'] = (isset($input['cd_display_header_enable']) &&  $input['cd_display_header_enable'] == 'true')? true : false;
				$output['cd_display_design'] = $input['cd_display_design'];
				$output['ta_text'] = (isset($input['ta_text']))? stripslashes($input['ta_text']) : '';
				$output['custom_child_header'] = stripslashes($input['custom_child_header']);
				$output['custom_css'] = stripslashes($input['custom_css']);
				$output['enable_three_cullum'] = (isset($input['enable_three_cullum']) && $input['enable_three_cullum'] == "true" )? true : false ;
				$output['debug_mode'] = (!isset($input['debug_mode']) || $input['debug_mode'] != "true" )? false : true ;
				$output['top_slider_loop'] = (isset($input['top_slider_loop']) && $input['top_slider_loop'] == "true" )? true : false ;

				$rbs->options = $output;
				$rbs->save_options();
				//update_option('biz_vektor_rbs_options', $output);

				break;
			case 'biz_vektor_rbs_options_reset':
				global $rbs; $rbs->reset_option();
				break;

			default:
				break;
		}
	}
}
//add_action('admin_init', 'biz_vektor_rbs_check_postdata');


function biz_vektor_get_rbs_theme_options(){
	//return get_option('biz_vektor_rbs_options', biz_vektor_gene_default_rbs_theme_options());
	$rbs = new rbs_theme_option;
	return $rbs->options;
}


/*-------------------------------------------*/
/*  カウントダウンウィジェット
/*-------------------------------------------*/

class biz_vektor_rbs_cowntdown extends WP_Widget {
	function biz_vektor_rbs_cowntdown() {
		$widget_ops = array(
			'classname' => 'biz_vektor_rbs_cowntdown',
			'description' => 'カウントダウンをします',
		);
		$widget_name = get_biz_vektor_name().'_カウントダウン';
		$this->WP_Widget('cdwn', $widget_name, $widget_ops);
	}

	function widget($args, $instance){
		biz_vektor_display_cowntdown(array('widget'));
	}
	function form($instance){	}
	function update($new_instance, $old_instance){	}
	function display_page($pageid,$titleflag=false) {
		$page = get_page($pageid);
		echo '<div id="widget-page-'.$pageid.'" class="sectionBox">';
		if($titleflag){ echo "<h2>".$page->post_title."</h2>"; }
		echo apply_filters('the_content', $page->post_content );
		echo '</div>';
	}
}
add_action('widgets_init', create_function('', 'return register_widget("biz_vektor_rbs_cowntdown");'));


class biz_vektor_rbs_cowntdown_main extends WP_Widget {
	function biz_vektor_rbs_cowntdown_main() {
		$widget_ops = array(
			'classname' => 'biz_vektor_rbs_cowntdown_main',
			'description' => 'カウントダウンをします(メインコンテンツ用)',
		);
		$widget_name = get_biz_vektor_name().'_カウントダウン_メインコンテンツ用';
		$this->WP_Widget('cdwn_main', $widget_name, $widget_ops);
	}

	function widget($args, $instance){
		$options = biz_vektor_get_rbs_theme_options();
		if($options['header_visual_disable']){
			biz_vektor_display_cowntdown(array('widget_main','header_area'));
		}
	}
	function form($instance){	}
	function update($new_instance, $old_instance){	}
	function display_page($pageid,$titleflag=false) {
		$page = get_page($pageid);
		echo '<div id="widget-page-'.$pageid.'" class="sectionBox">';
		if($titleflag){ echo "<h2>".$page->post_title."</h2>"; }
		echo apply_filters('the_content', $page->post_content );
		echo '</div>';
	}
}
add_action('widgets_init', create_function('', 'return register_widget("biz_vektor_rbs_cowntdown_main");'));

/*-------------------------------------------*/
/*	時限式ウィジェット
/*-------------------------------------------*/
class biz_vektor_rbs_timer extends WP_Widget {
	function biz_vektor_rbs_timer() {
		$widget_ops = array(
			'classname' => 'biz_vektor_rbs_timer',
			'description' => '指定した期間内にのみ表示されるウィジェットです',
		);
		$widget_name = get_biz_vektor_name().'_時限式ウィジェット';
		$this->WP_Widget('timer', $widget_name, $widget_ops);
	}

	function widget($args, $instance){
		if($instance['text'] != '' && $instance['limit_start'] <= time() && time() <= $instance['limit_end']){
			?>
			<div class="timer_widget">
				<?php echo $instance['text']; ?>
			</div>
			<?php
		}
	}

	function form($instance){
		$defaults = array(
			'text' => '',
			'limit_start' => time(),
			'limit_end'   => time()+30*24*60*60,
		);

		$instance = wp_parse_args((array) $instance, $defaults);
		?>
		<p>
		<textarea type="text" name="<?php echo $this->get_field_name('text'); ?>" ><?php echo $instance['text'];  ?></textarea>
		<br/>
		<label for="<?php echo $this->get_field_id('time_start'); ?>">開始時間
		<input type="date" name="<?php echo $this->get_field_name('limit_start_d'); ?>" value="<?php echo date('Y-m-d',$instance['limit_start']);  ?>" />
		<input type="time" name="<?php echo $this->get_field_name('limit_start_t'); ?>" value="<?php echo date('H:i',$instance['limit_start']);  ?>" /></label>
		<br/>
		<label for="<?php echo $this->get_field_id('time_start'); ?>">終了時間
		<input type="date" name="<?php echo $this->get_field_name('limit_end_d'); ?>" value="<?php echo date('Y-m-d',$instance['limit_end']);  ?>" />
		<input type="time" name="<?php echo $this->get_field_name('limit_end_t'); ?>" value="<?php echo date('H:i',$instance['limit_end']);  ?>" /></label>
		</p>
		<?php
	}

	function update($new_instance, $old_instance){
		$instance = $old_instance;
		$instance['text']         =   $new_instance['text'];
		$instance['limit_start']  =  ($new_instance['limit_start_d'] && $new_instance['limit_start_t'])? strtotime($new_instance['limit_start_d'].' '.$new_instance['limit_start_t'].":00") : time();
		$instance['limit_end']    =  ($new_instance['limit_end_d']   && $new_instance['limit_end_t']  )? strtotime($new_instance['limit_end_d'].' '.$new_instance['limit_end_t'].":00") : time()+30*24*60*60;
		return $instance;
	}

	function display_page($pageid,$titleflag=false) {
		$page = get_page($pageid);
		echo '<div id="widget-page-'.$pageid.'" class="sectionBox">';
		if($titleflag){ echo "<h2>".$page->post_title."</h2>"; }
		echo apply_filters('the_content', $page->post_content );
		echo '</div>';
	}
}
add_action('widgets_init', create_function('', 'return register_widget("biz_vektor_rbs_timer");'));


/*
* オプション管理クラス
*/
class rbs_theme_option{

	public $options = array();
	public $option_key = 'biz_vektor_rbs_options';
	function __construct(){
		$this->load_options();
  		//$this->reset_option();
	}

/*-------------------------------------------*/
/*  オプションをロード
/*-------------------------------------------*/
    private function load_options(){
		$this->options = get_option($this->option_key ,$this->make_default_option());
		$this->save_options();
    }


/*-------------------------------------------*/
/*  オプションを保存
/*-------------------------------------------*/
    public function save_options(){
        update_option($this->option_key , $this->options);
    }

/*-------------------------------------------*/
/*  オプションのデフォルト値をセット
/*
/*  @return = options =array()
/*-------------------------------------------*/
    public function make_default_option(){
		$options= array(
			///// cowntdown_widget
			'cd_text'                       =>  "スタートまで、あと",
			'cd_date'                       =>  "1595556000",		// Tokyo Orinpic 2020
			'ta_text'                       =>  "",
			'custom_child_header'           =>  '',
			'cd_display_header_enable'      =>  True,
			'cd_display_design'             =>  "2",
			///// Body
			'body_bg_size_ajust'            =>  True,
			'no-margin'                     =>  True,
			///// Three_cullum
			'enable_three_cullum'           =>  false,  // [true]->ThreeCullum | [false]-> nomal
			///// Common
			'key_color'                     =>  '#dd3333',
			///// header
			'header_visual_disable'         =>  false,
			'custom_css'                    =>  "/* これはサンプルです。 */\n#header{ min-height:95px; }\n#site-title img{ min-height: 100px; display: block; margin: auto; }",
			///// mainvisual
			'top_bg_background_enable'      =>  false,
			'top_bg_color_top'              =>  '#ddeefb',
			'top_bg_color_bot'              =>  '',
			'top_bg_image'                  =>  '',
			'top_bg_image_enable'           =>  false,
			'top_discription_text'          =>  'RBSマラソン',
			'top_slider_loop'               =>  true,
			///// mainarea setting
			'mainarea_radius'               =>  "none",   // area|[none]
			'main_bg_gradation_top'         =>  "#fcecd1",
			'main_bg_gradation_bot'         =>  false,
			'content_color'                 =>  "#666666",
			'content_bg_color'              =>  "#fff",
			///// footer setting
			'footer_bg_color'               =>  "#fcefd8",
			'footer_bg_image'               =>  "",
			'footer_bg_visible'             =>  true,    //default:true
			'footer_bg_image_position'      =>  "center center",
			'footer_bg_image_repeat'        =>  'repeat',   // no-repeat|[repeat]|repeat-x|repeat-y
			'footer_bg_image_enable'        =>  false,
			'footer_bg_image_opacity'       =>  false,
			'footer_bg_image_size'          =>  true,   // background-size:  [true]->cover | [false]->fixed
			'footer_menu_color'             =>  "#333333",
			///// global menu setting
			'menu_color'                    =>  "#ffffff",
			'menu_bg_color'                 =>  "#dd3333",
			'menu_bg_color_bot'             =>  "#ba2a2a",
			'menu_bg_image'                 =>  "",
			'menu_bg_image_enable'          =>  false,
			'menu_size_through'             =>  true,
			'menu_border_color'             =>  "#af1d18",
			'menu_block_radius'             =>  "none",   // [none]:parent:botton
			'menu_bg_visible_disable'       =>  false,    // True = background:none;
			'menu_position'                 =>  'top',    // top|[bottom]|left|right

			'debug_mode'                    =>  false,
		);

      return $options;
    }

   public function reset_option(){
   	$this->options = $this->make_default_option();
   	$this->save_options();
   }
   public function tellme(){
   	print_r($this->options);
   }

}
